#ifndef COORD_HPP
#define COORD_HPP

#include "Common.hpp"

class Coord
{
public:
    Coord() : x(0.0), y(0.0) {}
    Coord(double x_, double y_) : x(x_), y(y_) {}

    double x;
    double y;
};

inline Coord operator+(const Coord& a, const Coord& b)
{
    return Coord(a.x + b.x, a.y + b.y);
}

inline Coord operator-(const Coord& a, const Coord& b)
{
    return Coord(a.x - b.x, a.y - b.y);
}

inline Coord operator*(const Coord& a, double b)
{
    return Coord(a.x * b, a.y * b);
}

inline Coord operator/(const Coord& a, double b)
{
    return Coord(a.x / b, a.y / b);
}

inline double calcDot(const Coord& a, const Coord& b)
{
    return a.x * b.x + a.y * b.y;
}

inline double calcL2(const Coord& a)
{
    return a.x * a.x + a.y * a.y;
}

inline double calcD2(const Coord& a, const Coord& b)
{
    double dx = b.x - a.x;
    double dy = b.y - a.y;
    double d2 = dx * dx + dy * dy;
    return d2;
}

#endif
