#ifndef DEBUGGRAPHICS_HPP
#define DEBUGGRAPHICS_HPP

#include "Common.hpp"
#include "Problem.hpp"
#include "ThreadUtils.hpp"

class DebugGraphics
{
public:
    DebugGraphics();
    ~DebugGraphics();

    void create();
    void destroy();
    bool destroyed();

    void update(const Problem& problem,
                const Solution& solution,
                const std::string& text);
    void update(const Solution& solution,
                const std::string& text);

private:
    Problem m_problem;
    Thread m_thread;
    Mutex m_mutex;
    Solution m_solution;
    std::string m_text;
    bool m_destroy = false;
    bool m_destroyed = false;
    bool m_update = false;
    bool m_updateProblem = false;

private:
    DebugGraphics(const DebugGraphics& other) = delete;
    DebugGraphics(DebugGraphics&& other) = delete;
    DebugGraphics& operator=(const DebugGraphics& other) = delete;
    DebugGraphics& operator=(DebugGraphics&& other) = delete;
};

#endif
