#ifndef PROTOCOL_HPP
#define PROTOCOL_HPP

#include "Common.hpp"

namespace Protocol
{
    void init();
    void cleanup();

    bool getProblem(uint64_t id,
                    std::string* pProblemData,
                    std::string* pMsg = nullptr);
    bool getScoreboard(std::string* pScoreboardData,
                       std::string* pMsg = nullptr);
    bool getUserboard(std::string* pUserboardData,
                      std::string* pMsg = nullptr);
    bool submit(uint64_t id,
                const std::string& solutionData,
                std::string* pSubmissionId,
                std::string* pMsg = nullptr);
    bool updateUsername(const std::string& username,
                        std::string* pMsg = nullptr);
}

#endif
