#ifndef SCORES_HPP
#define SCORES_HPP

#include "Common.hpp"

class ScoreboardEntry
{
public:
    std::string username;
    double score = 0.0;
};

class Scoreboard
{
public:
    bool frozen = false;
    std::vector<ScoreboardEntry> entries;
    std::string updatedAt;
};

bool readScoreboard(std::string* pScoreboardData);
bool writeScoreboard(const std::string& scoreboardData);

bool parseScoreboard(const std::string& scoreboardData,
                     Scoreboard* pScoreboard,
                     std::string* pMsg = nullptr);
bool parseScoreboard(Scoreboard* pScoreboard,
                     std::string* pMsg = nullptr);

class UserboardEntry
{
public:
    bool valid = false;
    double score = 0.0;
};

class Userboard
{
public:
    std::vector<UserboardEntry> entries;
};

bool readUserboard(std::string* pUserboardData);
bool writeUserboard(const std::string& userboardData);

bool parseUserboard(const std::string& userboardData,
                    Userboard* pUserboard,
                    std::string* pMsg = nullptr);
bool parseUserboard(Userboard* pUserboard,
                    std::string* pMsg = nullptr);

void getMyScores(const Userboard& userboard,
                 std::vector<int64_t>* pMyScores);

#endif
