#include "Common.hpp"
#include "Cleanup.hpp"
#include "ProblemCount.hpp"
#include "Protocol.hpp"
#include "Problem.hpp"

using std::string;

int main(int argc, char *argv[])
{
    Protocol::init();
    Cleanup cleanupProtocol([](){ Protocol::cleanup(); });

    for (uint64_t id = 1; id <= problemCount; id++)
    {
        printf("%4" PRIu64 ": ", id);
        fflush(stdout);

        string existingProblemData;
        if (readProblem(id, &existingProblemData))
        {
            printf("exists\n");
            continue;
        }

        string msg;
        string problemData;
        if (!Protocol::getProblem(id, &problemData, &msg))
        {
            printf("%s\n", msg.c_str());
            continue;
        }

        if (!writeProblem(id, problemData))
        {
            printf("Error writing file\n");
            continue;
        }

        printf("ok\n");
    }

    return 0;
}
