#include "Common.hpp"
#include "Cleanup.hpp"
#include "Protocol.hpp"
#include "Scores.hpp"

using std::string;

int main(int argc, char *argv[])
{
    string msg;

    Protocol::init();
    Cleanup cleanupProtocol([](){ Protocol::cleanup(); });

    string scoreboardData;
    if (!Protocol::getScoreboard(&scoreboardData, &msg))
    {
        printf("%s\n", msg.c_str());
        return 1;
    }

    Scoreboard scoreboard;
    if (!parseScoreboard(scoreboardData, &scoreboard, &msg))
    {
        printf("%s\n", msg.c_str());
        return 1;
    }

    if (!writeScoreboard(scoreboardData))
    {
        printf("Error writing scoreboard\n");
        return 1;
    }

    return 0;
}
