#include "Common.hpp"
#include "Cleanup.hpp"
#include "Protocol.hpp"
#include "Scores.hpp"

using std::string;

int main(int argc, char *argv[])
{
    string msg;

    Protocol::init();
    Cleanup cleanupProtocol([](){ Protocol::cleanup(); });

    string userboardData;
    if (!Protocol::getUserboard(&userboardData, &msg))
    {
        printf("%s\n", msg.c_str());
        return 1;
    }

    Userboard userboard;
    if (!parseUserboard(userboardData, &userboard, &msg))
    {
        printf("%s\n", msg.c_str());
        return 1;
    }

    if (!writeUserboard(userboardData))
    {
        printf("Error writing userboard\n");
        return 1;
    }

    return 0;
}
