#include "Common.hpp"
#include "Scores.hpp"
#include "FormatUtils.hpp"

using std::string;
using std::vector;

int main(int argc, char *argv[])
{
    string msg;

    Scoreboard scoreboard;
    if (!parseScoreboard(&scoreboard, &msg))
    {
        printf("%s\n", msg.c_str());
        return 1;
    }

    printf("Frozen: %s\n", scoreboard.frozen ? "true" : "false");
    printf("Last updated: %s\n", scoreboard.updatedAt.c_str());
    printf("\n");
    uint64_t rank = 0;
    for (auto& entry : scoreboard.entries)
    {
        rank++;
        string username = entry.username;
        bool isMe = (username == "Frictionless Bananas");
#if 0
        for (auto& ch : username)
        {
            if (ch < (char)32 || ch > (char)126)
            {
                ch = '?';
            }
        }
#endif
        constexpr size_t maxSize = 57;
        if (username.size() > maxSize)
        {
            username.resize(maxSize - 3);
            username += "...";
        }
        else
        {
            username.resize(maxSize, ' ');
        }
        int64_t score = (int64_t)entry.score;
        printf("%s%3" PRIu64 "  %15s  %s%s\n", isMe ? "\x1b[7m" : "", rank, formatWithCommas(score).c_str(), username.c_str(), isMe ? "\x1b[0m" : "");
    }

    return 0;
}
